#ifndef _PARSER
#define _PARSER
#include <assert.h>
#include <malloc.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "constants.h"
#include "matrix.h"

extern int cont_words;
extern char **words;
extern char directed;
extern int *loc_con;
extern int **len_words;
extern int **MAPPA;

typedef struct OBJ {
  int key;
  int idx;
}Obj;

typedef struct PQ {
  Obj *dist;
  int heapsize;
}PriorityQueue;

int   Right_Parser(int x,PriorityQueue *PQ);
int   Left_Parser(int x,PriorityQueue *PQ);
int   Parent_Parser(int x);
void  Insert_Parser(PriorityQueue **PQ,int key,int idx);
void  Heapify_Parser(PriorityQueue **PQ,int i);
int   Dequeue_Parser(PriorityQueue **PQ);
void  AllPairShortestPath(int n,int **Adj,int *cont,int ***pred,int ***Dis);
void  Visual_Parser(int start,int i,int num,char **types,int **pred,int num_grafo);
void  ParserAllPairShortestPath(FILE *fp,char ***name,int *num_grafo);
void  ParserSubdue(FILE *fp,int *num_grafo,char ***name,int **size,int ***Mat);

#endif
